using UnityEngine;using System.Collections;using SimpleJSON;using System.Collections.Generic;using MVR.FileManagementSecure;using System.Linq;using Battlehub.RTCommon;using System.Text.RegularExpressions;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using AssetBundles;using UnityEngine.UI;using MeshVR;namespace PluginIdea.P2S{public class Picture2Skybox : MVRScript{private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();private List<string> typeStrs = new List<string>{"360", "180"};private List<string> layoutStrs = new List<string>{"None","Side By Side", "Up Down"};private TextureSettings maskTextureSetting = new TextureSettings(){compress = false, linearColor = false, createMipMaps = false};private JSONStorableStringChooser skyboxType;private JSONStorableUrl MainTexUrl;private JSONStorableFloat exposure, rotation;private JSONStorableColor color;private JSONStorableStringChooser types, layout;private Texture2D mainTex;private Material Mat;private Renderer skyboxSphereRd;private Request request;private bool isExternalResourcesLoaded;private const string defaultSkyboxPath = "Custom/Assets/PluginIdea/SkyboxTextures";public static bool IsChinease{get{return Application.systemLanguage == SystemLanguage.Chinese;}}public override void Init(){Utils.OnInitUI(CreateUIElement);RegistBundleUnload();FileManagerSecure.CreateDirectory(defaultSkyboxPath);string assetsBundlePath = Utils.GetPluginPath(this) + "/resources/img2skybox.assetbundle";request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);var btn = Utils.SetupButton(this, "Get More......", () =>{if (IsChinease) Application.OpenURL(@"https:\/\/afdian.net/p/6f6685ceae9211ed8c8952540025c377");else Application.OpenURL(@"https:\/\/www.patreon.com/PluginIdea/about");}, false);btn.buttonImage.color = Color.yellow;Utils.SetupSpacer(this, 30, false);Utils.SetupInfoTextNoScroll(this, "<b><size=40>Picture To Skybox</size></b>", 300, true);color = Utils.SetupColor(this, "Color", new Color(0.5f,0.5f,0.5f,0.5f), false);color.setCallbackFunction = (h, s, v) =>{if (!isExternalResourcesLoaded) return;Mat.SetColor("_Tint", Color.HSVToRGB(h, s, v));};MainTexUrl = Utils.SetupTexture2DChooser(this, "Choose a Skybox Texture", defaultSkyboxPath, false, maskTextureSetting, (tex) =>{if (!isExternalResourcesLoaded) return;if (mainTex != null) Destroy(mainTex);mainTex = tex;Mat.mainTexture = mainTex;});Utils.SetupTwinButton(this,"Reload", () =>{Destroy(Mat.GetTexture("_MainTex"));MainTexUrl.Reload();}, "Remove", () =>{Destroy(Mat.GetTexture("_MainTex"));}, false);exposure = Utils.SetupSliderFloat(this, "Exposure", 1, 0, 3, false);exposure.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;Mat.SetFloat("_Exposure", val);};rotation = Utils.SetupSliderFloat(this, "Rotation", 0, 0, 360, false);rotation.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;Mat.SetFloat("_Rotation", val);};layout = Utils.SetupStringChooser(this, "3D Layout", layoutStrs, false);layout.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;switch (val){case "None": Mat.SetFloat("_Layout", 0);break;case "Side By Side": Mat.SetFloat("_Layout", 1);break;case "Up Down": Mat.SetFloat("_Layout", 2);break;default:                        break;}};types = Utils.SetupStringChooser(this, "Type", typeStrs, false);types.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;switch (val){case "360": Mat.SetFloat("_ImageType", 0);break;case "180": Mat.SetFloat("_ImageType", 1);break;default:                        break;}};}private Button hardResetBtn;private void RegistBundleUnload(){hardResetBtn = SuperController.singleton.mainHUD.Find("MainUICanvas/Panel/Content/TabFile/Content/Hard Reset Button").GetComponent<Button>();hardResetBtn.onClick.AddListener(UnloadBundle);}private void UnloadBundle(){if (request.assetBundle != null){request.assetBundle.Unload(false);}}private void OnAssetBundleLoaded(Request abffr){Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){if (!dic_BundleShaders.ContainsKey(shaders[i].name)){string key = shaders[i].name;dic_BundleShaders.Add(key, shaders[i]);}}Mat = new Material(dic_BundleShaders["Skybox/Panoramic"]);skyboxSphereRd = GameObject.CreatePrimitive(PrimitiveType.Sphere).GetComponent<MeshRenderer>();skyboxSphereRd.GetComponent<Collider>().enabled = false;skyboxSphereRd.name = "__skyboxSpere";skyboxSphereRd.material = Mat;skyboxSphereRd.transform.localScale = 900 * Vector3.one;skyboxSphereRd.transform.position = Vector3.zero;skyboxSphereRd.transform.rotation = Quaternion.identity;isExternalResourcesLoaded = true;MainTexUrl.Reload();color.setCallbackFunction(color.val.H, color.val.S, color.val.V);exposure.setCallbackFunction(exposure.val);rotation.setCallbackFunction(rotation.val);layout.setCallbackFunction(layout.val);types.setCallbackFunction(types.val);}private void OnDestroy(){if (skyboxSphereRd != null) Destroy(skyboxSphereRd.gameObject);if (hardResetBtn != null){hardResetBtn.onClick.RemoveListener(UnloadBundle);}Utils.OnDestroyUI();}}}